from rest_framework import serializers
from .models import *

class LocationSerializer(serializers.ModelSerializer):
    class Meta:
        model = Location
        fields="__all__"

class DrDataSerializer(serializers.ModelSerializer):
    class Meta:
        model = DrData
        fields="__all__"


class DrDeductionSerializer(serializers.ModelSerializer):
    creation_day= serializers.SerializerMethodField()
    creation_time= serializers.SerializerMethodField()
    created_at = serializers.DateTimeField(format="%H:%M,%Y-%m-%d",required=False)
    class Meta:
        model = DrDeduction
        fields="__all__"
        read_only_fileds=("creation_day","creation_time")
    def get_creation_day(self, obj):
        return obj.created_at.strftime("%Y-%m-%d")
    def get_creation_time(self, obj):
        return obj.created_at.strftime("%I:%M %p")
    def to_representation(self, instance):
        obj = super().to_representation(instance)
        deduction_name = instance.deduction.name
        obj['deduction'] = deduction_name
        obj['action_name'] = deduction_name
        obj['created_by'] = instance.created_by.name
        #obj['created_by'] = instance.created_by.get_full_name() 
        return obj
#https://pynative.com/python-datetime-format-strftime/
class DrEarningSerializer(serializers.ModelSerializer):
    creation_day= serializers.SerializerMethodField()
    creation_time= serializers.SerializerMethodField()
    class Meta:
        model = DrEarning
        fields="__all__"
        read_only_fileds=("creation_day","creation_time")
    def get_creation_day(self, obj):
        return obj.created_at.strftime("%Y-%m-%d")
    def get_creation_time(self, obj):
        return obj.created_at.strftime("%I:%M %p")
    def to_representation(self, instance):
        obj = super().to_representation(instance)
        earning_name = instance.earning.name
        obj['earning'] = earning_name
        obj['action_name'] = earning_name
        obj['created_by'] = instance.created_by.name
        #obj['created_by'] = instance.created_by.get_full_name() 
        return obj
class EarningSerializer(serializers.ModelSerializer):
    class Meta:
        model = Earning
        fields="__all__"

class DrSalarySerializer(serializers.ModelSerializer):
    class Meta:
        model = DrSalary
        fields="__all__"

# from clauthApp.models import BranchDoctor,BranchReception
# from .models import * 


# class BranchDoctorsSerializer(serializers.ModelSerializer):
#     class Meta:
#         model = BranchDoctor
#         fields ="__all__"


# class BranchReceptionsSerializer(serializers.ModelSerializer):
#     class Meta:
#         model = BranchReception
#         fields ="__all__"


